/*---------------------------------------------------
-----------------------------------------------------
Filename:	BODY.m
Version:	1.0
Type:		maki
Date:		28. Aug. 2020 - 22:34
Author:		Tankevich Denis aka Defix 
E-Mail:		Defixmail@gmail.com
Internet:	www.severm.kz

-----------------------------------------------------
---------------------------------------------------*/



#include "std.mi"
#include "attribs/init_appearance.m"

function SetBODYNum();
function SetICONNum();
function SetDispNum();
function SetATRDD(); 


Global Group SUIGrp;
Global Group PLGrp;
Global Group NormalGrp;
Global Group NormalDisp1;
Global Group NormalDisp2;


Global Group EQGrp;
Global Group CONFGrp;

Global Container SUIcont;
Global Container PLcont;
Global Container EQcont;
Global Container CONFcont;


Global Group scriptGroup;

Global Layer BGmain;
Global Layer BGpl;
Global Layer BGsui;
Global Layer BGeq;
Global Layer BGconf;

Global Layer LayCON;
Global Layer LayPIC;
Global Layer LayPIC2;


Global Button SwIconNext;
Global Button SwIconPrev;

Global Button SwButtNext;
Global Button SwButtPrev;

Global Button SwDispNext;
Global Button SwDispPrev;

Global int curBODY;
Global int curICON;
Global int curDisp;



System.onScriptLoaded()
{

    initAttribs_Appearance();
	scriptGroup = getScriptGroup();
    NormalGrp = System.getContainer("main").getLayout("normal");
    
	NormalDisp1 = NormalGrp.getObject("player.display1");
	NormalDisp2 = NormalGrp.getObject("player.display2");
	
	SUIcont = getContainer("sui");
	SUIGrp = SUIcont.getLayout("normal");
	
	PLcont = getContainer("pledit");
	PLGrp = PLcont.getLayout("normal");
	
	EQcont = getContainer("Eq");
	EQGrp = EQcont.getLayout("normal");
	
	CONFcont = getContainer("Config");
	CONFGrp = CONFcont.getLayout("normal");
	
	
	BGmain = NormalGrp.getObject("BG2");
	LayCON = NormalGrp.getObject("LayCON");
	LayPIC = NormalGrp.getObject("LayPIC");
	LayPIC2 = PLGrp.getObject("LayPIC");
	
	BGpl = PLGrp.findObject("BGPL");
    BGsui = SUIGrp.findObject("BGSUI");
	
	BGeq = EQGrp.findObject("BGEQ");
	BGconf = CONFGrp.findObject("BGCONF");
	
	SwButtPrev = scriptGroup.findObject("SwButtPrev");
    SwButtNext = scriptGroup.findObject("SwButtNext");
	
	SwIconNext = scriptGroup.findObject("SwIconNext");
    SwIconPrev = scriptGroup.findObject("SwIconPrev");
	
	SwDispNext = scriptGroup.findObject("SwDispNext");
    SwDispPrev = scriptGroup.findObject("SwDispPrev");
	
	
	curBODY = getPrivateInt(getSkinName(), "lastcurBODY", curBODY);
    curICON = getPrivateInt(getSkinName(), "lastcurICON", curICON);
	curDisp = getPrivateInt(getSkinName(), "lastcurDisp", curDisp);
	
	if (curBODY == "") curBODY = 1;
    
	if (curICON == "") curICON = 1;
    
	if (curDisp == "") curDisp = 1;
	
	SetBODYNum();
	SetICONNum();
	SetDispNum();
	
	SetATRDD();
}

SetATRDD() 
{

    if (Drag_and_drop.getData() == "1")
    { 
    BGmain.setXmlParam("move", "1");
	BGpl.setXmlParam("move", "1");	
	BGsui.setXmlParam("move", "1");	
	BGeq.setXmlParam("move", "1");	
	BGconf.setXmlParam("move", "1");
    }
		
		
	else
    { 
	BGmain.setXmlParam("move", "0");
	BGpl.setXmlParam("move", "0");	
	BGsui.setXmlParam("move", "0");	
	BGeq.setXmlParam("move", "0");	
	BGconf.setXmlParam("move", "0");
    }	
 }		
	



Drag_and_drop.onDataChanged()
{
	if (getData() == "1")
	{	
	BGmain.setXmlParam("move", "1");
	BGpl.setXmlParam("move", "1");	
	BGsui.setXmlParam("move", "1");	
	BGeq.setXmlParam("move", "1");	
	BGconf.setXmlParam("move", "1");
	}

	else if(getData() == "0")
	{
	
	BGmain.setXmlParam("move", "0");
	BGpl.setXmlParam("move", "0");	
	BGsui.setXmlParam("move", "0");	
	BGeq.setXmlParam("move", "0");	
	BGconf.setXmlParam("move", "0");	
	} 
}





//----------------------------------------------------------------------------------------------------------------
// SET BG
//----------------------------------------------------------------------------------------------------------------

 SetBODYNum() {

	if (curBODY == 1) { 
	
	BGmain.setXmlParam("image", "BG1");
	BGpl.setXmlParam("image", "BG1");
    BGsui.setXmlParam("image", "BG1");
	BGeq.setXmlParam("image", "BG1");
	BGconf.setXmlParam("image", "BG1");
	
	
	BGmain.setXmlParam("tile", "0");
	BGpl.setXmlParam("tile", "0");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "0");	
	BGconf.setXmlParam("tile", "0");
	
	} 	
	
	if (curBODY == 2) { 
	
	BGmain.setXmlParam("image", "BG2");
	BGpl.setXmlParam("image", "BG2");
    BGsui.setXmlParam("image", "BG2");
	BGeq.setXmlParam("image", "BG2");
	BGconf.setXmlParam("image", "BG2");
	
	BGmain.setXmlParam("tile", "0");
	BGpl.setXmlParam("tile", "0");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "0");	
	BGconf.setXmlParam("tile", "0");
	
	} 
	
	if (curBODY == 3) { 
	
	BGmain.setXmlParam("image", "BG3");
	BGpl.setXmlParam("image", "BG3");
    BGsui.setXmlParam("image", "BG3");
	BGeq.setXmlParam("image", "BG3");
	BGconf.setXmlParam("image", "BG3");
	
	BGmain.setXmlParam("tile", "0");
	BGpl.setXmlParam("tile", "0");	
	BGsui.setXmlParam("tile", "0");	
	BGeq.setXmlParam("tile", "0");	
	BGconf.setXmlParam("tile", "0");
	
	} 
	
	if (curBODY == 4) { 
	
	BGmain.setXmlParam("image", "BG4");
	BGpl.setXmlParam("image", "BG4");
    BGsui.setXmlParam("image", "BG4");
	BGeq.setXmlParam("image", "BG4");
	BGconf.setXmlParam("image", "BG4");
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 
	
	if (curBODY == 5) { 
	
	BGmain.setXmlParam("image", "BG5");
	BGpl.setXmlParam("image", "BG5");
    BGsui.setXmlParam("image", "BG5");
	BGeq.setXmlParam("image", "BG5");
	BGconf.setXmlParam("image", "BG5");
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	
	} 
	
	if (curBODY == 6) { 
	
	BGmain.setXmlParam("image", "BG6");
	BGpl.setXmlParam("image", "BG6");
    BGsui.setXmlParam("image", "BG6");
	BGeq.setXmlParam("image", "BG6");
	BGconf.setXmlParam("image", "BG6");
	
	BGmain.setXmlParam("tile", "0");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "0");	
	BGconf.setXmlParam("tile", "0");
	
	} 
	
	if (curBODY == 7) { 
	
	BGmain.setXmlParam("image", "BG7");
	BGpl.setXmlParam("image", "BG7");
	BGsui.setXmlParam("image", "BG7");
	BGeq.setXmlParam("image", "BG7");
	BGconf.setXmlParam("image", "BG7");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 


	if (curBODY == 8) { 
	
	BGmain.setXmlParam("image", "BG8");
	BGpl.setXmlParam("image", "BG8");
	BGsui.setXmlParam("image", "BG8");
	BGeq.setXmlParam("image", "BG8");
	BGconf.setXmlParam("image", "BG8");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 
	
	if (curBODY == 9) { 
	
	BGmain.setXmlParam("image", "BG9");
	BGpl.setXmlParam("image", "BG9");
	BGsui.setXmlParam("image", "BG9");
	BGeq.setXmlParam("image", "BG9");
	BGconf.setXmlParam("image", "BG9");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 

	if (curBODY == 10) { 
	
	BGmain.setXmlParam("image", "BG10");
	BGpl.setXmlParam("image", "BG10");
	BGsui.setXmlParam("image", "BG10");
	BGeq.setXmlParam("image", "BG10");
	BGconf.setXmlParam("image", "BG10");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 
	
	if (curBODY == 11) { 
	
	BGmain.setXmlParam("image", "BG11");
	BGpl.setXmlParam("image", "BG11");
	BGsui.setXmlParam("image", "BG11");
	BGeq.setXmlParam("image", "BG11");
	BGconf.setXmlParam("image", "BG11");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 

	if (curBODY == 12) { 
	
	BGmain.setXmlParam("image", "BG12");
	BGpl.setXmlParam("image", "BG12");
	BGsui.setXmlParam("image", "BG12");
	BGeq.setXmlParam("image", "BG12");
	BGconf.setXmlParam("image", "BG12");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 
	
	if (curBODY == 13) { 
	
	BGmain.setXmlParam("image", "BG13");
	BGpl.setXmlParam("image", "BG13");
	BGsui.setXmlParam("image", "BG13");
	BGeq.setXmlParam("image", "BG13");
	BGconf.setXmlParam("image", "BG13");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 
	
	if (curBODY == 14) { 
	
	BGmain.setXmlParam("image", "BG14");
	BGpl.setXmlParam("image", "BG14");
	BGsui.setXmlParam("image", "BG14");
	BGeq.setXmlParam("image", "BG14");
	BGconf.setXmlParam("image", "BG14");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 
	
	if (curBODY == 15) { 
	
	BGmain.setXmlParam("image", "BG15");
	BGpl.setXmlParam("image", "BG15");
	BGsui.setXmlParam("image", "BG15");
	BGeq.setXmlParam("image", "BG15");
	BGconf.setXmlParam("image", "BG15");
	
	
	BGmain.setXmlParam("tile", "1");
	BGpl.setXmlParam("tile", "1");	
	BGsui.setXmlParam("tile", "1");	
	BGeq.setXmlParam("tile", "1");	
	BGconf.setXmlParam("tile", "1");
	} 

}



SwButtPrev.onLeftClick() {
 
  if (curBODY > 1) { 
  curBODY = curBODY - 1; 
  } else { 
  curBODY = 15; 
  } 

  if ((curBODY>=1) && (curBODY<=15))
  
  setPrivateInt(getSkinName(), "lastcurBODY", curBODY);
	
  SetBODYNum();
}



SwButtNext.onLeftClick() {
 
  if (curBODY < 15) { 
  curBODY = curBODY + 1; 
  } else { 
  curBODY = 1; 
  } 

  if ((curBODY>=1) && (curBODY<=15))
 
  setPrivateInt(getSkinName(), "lastcurBODY", curBODY);
	
  SetBODYNum();
}





//----------------------------------------------------------------------------------------------------------------
// SET PIC
//----------------------------------------------------------------------------------------------------------------




SwIconPrev.onLeftClick() {
 
  if (curICON > 1) { 
  curICON = curICON - 1; 
  } else { 
  curICON = 13; 
  } 

  if ((curICON>=1) && (curICON<=13))
  
  setPrivateInt(getSkinName(), "lastcurICON", curICON);
	
  SetICONNum();
}



SwIconNext.onLeftClick() {
 
  if (curICON < 13) { 
  curICON = curICON + 1; 
  } else { 
  curICON = 1; 
  } 

  if ((curICON>=1) && (curICON<=13))
 
  setPrivateInt(getSkinName(), "lastcurICON", curICON);
	
  SetICONNum();
}



 SetICONNum() {

	if (curICON == 1) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.hide();
	
	
	} 	
	
	
	
	if (curICON == 2) { 
	LayPIC.hide();
	LayPIC2.hide();
	LayCON.show();
    LayCON.setXmlParam("image", "ICON2");
	} 
	
	
	
	if (curICON == 3) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON3");
	} 
	
	
	
	
	if (curICON == 4) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON4");
	} 
	
	
	
	
	if (curICON == 5) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
	LayCON.setXmlParam("image", "ICON5");
	} 
	
	
	
	
	if (curICON == 6) { 
	LayPIC.hide();
	LayPIC2.hide();
		
	LayCON.show();
	LayCON.setXmlParam("image", "ICON6");
	
	
	} 
	
	
	if (curICON == 7) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON7");
	} 




	if (curICON == 8) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON8");
	} 
	
	
	
	
	if (curICON == 9) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON9");
	} 




	if (curICON == 10) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON10");
	} 
	
	
	
	
	if (curICON == 11) { 
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
    LayCON.setXmlParam("image", "ICON11");
	
	
	} 




	if (curICON == 12) { 
	
	LayPIC.hide();
	LayPIC2.hide();
	
	LayCON.show();
	LayCON.setXmlParam("image", "ICON12");
	} 
	
	
	
	
	if (curICON == 13) { 
	
    LayPIC.show();
	LayPIC2.show();
	
	LayCON.hide();
	LayPIC.setXmlParam("image", "LaYPIC1");
    LayPIC2.setXmlParam("image", "LaYPIC1");



	} 
	
	
	
	if (curICON == 14) { 
    LayCON.hide();

	LayPIC.show();
	LayPIC2.show();
	
    LayPIC.setXmlParam("image", "LaYPIC2");
    LayPIC2.setXmlParam("image", "LaYPIC2");
	} 
	
	
	
	if (curICON == 15) { 
	LayCON.hide();
	LayPIC.show();
	LayPIC.show();
	
    LayPIC.setXmlParam("image", "LaYPIC3");
	LayPIC2.setXmlParam("image", "LaYPIC3");

	} 

}



//----------------------------------------------------------------------------------------------------------------
// SET DISP
//----------------------------------------------------------------------------------------------------------------



SwDispPrev.onLeftClick() {
 
  if (curDisp > 1) { 
  curDisp = curDisp - 1; 
  } else { 
  curDisp = 2; 
  } 

  if ((curDisp>=1) && (curDisp<=2))
  
  setPrivateInt(getSkinName(), "lastcurDisp", curDisp);
	
  SetDispNum();
}



SwDispNext.onLeftClick() {
 
  if (curDisp < 2) { 
  curDisp = curDisp + 1; 
  } else { 
  curDisp = 1; 
  } 

  if ((curDisp>=1) && (curDisp<=2))
 
  setPrivateInt(getSkinName(), "lastcurDisp", curDisp);
	
  SetDispNum();
}


 SetDispNum() 
 
 {

	if (curDisp == 1) { 
    NormalDisp1.show();
	NormalDisp2.hide();
	
	} 	
	
	
	
	if (curDisp == 2) { 
	
	NormalDisp1.hide();
	NormalDisp2.show();
 
	} 
	

}

