/********************************************************\
**  Filename:	coverflow.m				**
**  Version:	1.0					**
**  Date:	20. Nov. 2007 - 15:25			**
**********************************************************
**  Type:	winamp.wasabi/maki			**
**  Project:	Cover Flow				**
**********************************************************
**  Author:	Martin Poehlmann aka Deimos		**
**  E-Mail:	martin@skinconsortium.com		**
**  Internet:	http://www.skinconsortium.com		**
**		http://home.cs.tum.edu/~poehlman	**
**  Victhor mod 2017: removed 2 cover from the total. The purpose of this script is different now.
**********************************************************
**  Type:	winamp.wasabi/maki			**
**  Project:	Cover Flow				**
**********************************************************
** Tankevich Denis(Def) mods 2020 **
\********************************************************/


#include "std.mi"
#include "lib/pldir.mi"
#include "lib/com/songinfo.m"
#include "attribs/init_appearance.m"

Function update();
Function fade (GuiObject o, int alpha, float s);

Class GuiObject AlbumCover, curr_bg, prev1_bg, prev2_bg, next1_bg, next2_bg;

Global AlbumCover prev2, prev1, curr, next1, next2;
Global AlbumArtLayer currL;

Global String sprev2, sprev1, scurr, snext1, snext2;
Global text info;
Global layer info_bg,  COVDispOff;
Global Group scriptGroup, sG;
Global PlEdit PleditListener;

Global Timer delay, delay2;



System.onScriptLoaded ()
{
	initAttribs_Appearance();
	sG = getScriptGroup();	
	scriptGroup = sG.getObject("coverflowG");
	COVDispOff = scriptGroup.findObject("COV.OFF");
	COVDispOff.setXmlParam("Alpha", "255");
	PleditListener = new PlEdit;
	
	prev2 = scriptGroup.getObject("aa.prev2");
	prev1 = scriptGroup.getObject("aa.prev1");
	curr = scriptGroup.getObject("aa.curr");
	next1 = scriptGroup.getObject("aa.next1");
	next2 = scriptGroup.getObject("aa.next2");

	currL = scriptGroup.getObject("aa.curr");



	delay = new Timer;
	delay.setDelay(10);
	
	delay2 = new Timer;
	delay2.setDelay(10);
	
	scriptGroup.show();
	if (scriptGroup.isVisible() == 1) delay.start();
	
}

System.onScriptUnloading ()
{
	delay.stop();
	delay2.stop();
	delete delay;
	delete delay2;


}


//----------------------------------------------------------------------------------------------------------------
// Load start
//----------------------------------------------------------------------------------------------------------------
scriptGroup.onSetVisible(int on) 
{
	if (on)
	{
		if (File_info_anim_attrib.getData() == "1")
		{
		COVDispOff.setXmlParam("Alpha", "255");
		delay2.start();  
		return;
		}
	}

	else 
	{
		if (File_info_anim_attrib.getData() == "1")
		{
		COVDispOff.setXmlParam("Alpha", "255");
		return;
		}
	}
    COVDispOff.setXmlParam("Alpha", "0");
	return;
}


delay2.onTimer()// Delay to load cover art
{
  
    COVDispOff.setTargetA(0);
	COVDispOff.setTargetSpeed(0.30);
	COVDispOff.gotoTarget();
	update();
    delay2.stop();
   
}



//----------------------------------------------------------------------------------------------------------------
// Load end
//----------------------------------------------------------------------------------------------------------------

System.onTitleChange (String newtitle)
{
	 update();
}


update ()
{



  int cur = PlEdit.getCurrentIndex();
  int max = PlEdit.getNumTracks();

  sprev2 = PlEdit.getTitle(cur-2);
  sprev1 = PlEdit.getTitle(cur-1);
  scurr = PlEdit.getTitle(cur);
  snext1 = PlEdit.getTitle(cur+1);
  snext2 = PlEdit.getTitle(cur+2);

  songinfo_reload();
    
  String isstreamv = getPlayItemMetaDataString("streamtype");
  if (isstreamv != "") { curr.setXMLParam("notfoundimage", "cover.sc" ); }
  
    
	if (cur < 1)
	{
	
    next1.setXmlParam("source", PlEdit.getFileName(cur+1));
    next2.setXmlParam("source", PlEdit.getFileName(cur+2));
    prev1.setXmlParam("source", PlEdit.getFileName(cur+3));
	prev2.setXmlParam("source", PlEdit.getFileName(cur+4));
	
	prev2.show();
	prev1.show();

	 
	next1.show();
    next2.show();


    if (songinfo_isStream == 0) curr.setXMLParam("notfoundimage", "LOGO.Alb");
	
   }
   
	else if (cur >= 0 && cur <= max-2)
	{
    
    next1.setXmlParam("source", PlEdit.getFileName(cur+1));
    next2.setXmlParam("source", PlEdit.getFileName(cur+2));
    prev1.setXmlParam("source", PlEdit.getFileName(cur+3));
	prev2.setXmlParam("source", PlEdit.getFileName(cur+4));
	
	prev2.show();
	prev1.show();
	next1.show();
    next2.show();

    if (songinfo_isStream == 0) curr.setXMLParam("notfoundimage", "LOGO.Alb");
  
   }
   

	
  else if (cur >= max-1)
  {
	
    next1.setXmlParam("source", PlEdit.getFileName(cur-1));
    next2.setXmlParam("source", PlEdit.getFileName(cur-2));
    prev1.setXmlParam("source", PlEdit.getFileName(cur-3));
	prev2.setXmlParam("source", PlEdit.getFileName(cur-4));
	
	prev2.show();
	prev1.show();
	next1.show();
    next2.show();
    
    if (songinfo_isStream == 0) curr.setXMLParam("notfoundimage", "LOGO.Alb");
        

  }
    
}



PleditListener.onPleditModified ()
{
	if (delay) delay.start();
}

delay.onTimer ()
{
	delay.stop();
	update();
}


