/*---------------------------------------------------
-----------------------------------------------------
Filename:	init_appearance.m
Version:	2.2

Type:		maki/attrib definitions
Date:		28. Jun. 2007 - 22:08 
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
-----------------------------------------------------
Depending Files:
		scripts/mainmenu.maki
		scripts/visualizer.maki
		scripts/beatvisualization.maki
		scripts/shadesize.maki
		scripts/mcvcore.maki
-----------------------------------------------------
---------------------------------------------------*/

#ifndef included
#error This script can only be compiled as a #include
#endif

#include "gen_pageguids.m"
#include "../lib/fileio.mi"
#include "../lib/application.mi"

Function initAttribs_Appearance();

#define CUSTOM_PAGE_APPEARANCE "{F1036C9C-3919-47ac-8494-366778CF10F9}"

Global ConfigAttribute menubar_main_attrib;
Global ConfigAttribute tabs_main_attrib;
//Global ConfigAttribute tabs_hide_attrib;
Global ConfigAttribute tabs_show_attrib;
Global configAttribute winamplogo_attrib;
Global configAttribute artist_info_buttons_attrib;
//Global ConfigAttribute tips_attrib;
Global ConfigAttribute wacup_attrib; // v1.1
Global ConfigAttribute waveseeker_attrib; // v1.1
Global ConfigItem custom_page_appearance;
Global File myDoc; // v1.1

initAttribs_Appearance()
{

	initPages();

	custom_page_appearance = addConfigSubMenu(optionsmenu_page, "Appearance", CUSTOM_PAGE_APPEARANCE);

  myDoc = new File; // v1.1..
  String temp = (Application.GetSettingsPath()+"/WACUP_Tools/koopa.ini");
  myDoc.load (temp);
  if(myDoc.exists())
  {
    ConfigItem wacup_check = addConfigSubMenu(custom_page_nonexposed, "wacupCheck", CUSTOM_PAGE_NONEXPOSED);
    wacup_attrib = wacup_check.newAttribute("Is Wacup", "1");
  }
  else
  {
    ConfigItem wacup_check = addConfigSubMenu(custom_page_nonexposed, "wacupCheck", CUSTOM_PAGE_NONEXPOSED);
    wacup_attrib = wacup_check.newAttribute("Is Wacup", "0");
  }
  

  if(wacup_attrib.getData() == "1")
  {
    winamplogo_attrib = custom_page_appearance.newAttribute("Show WACUP Logo", "1");
  }
  else
  {
    winamplogo_attrib = custom_page_appearance.newAttribute("Show Winamp Logo", "1");
  } // ..v1.1
  
	menubar_main_attrib = custom_page_appearance.newAttribute("Show Main Window Menu", "1");
  
	addMenuSeparator(custom_page_appearance);

	artist_info_buttons_attrib = custom_page_appearance.newAttribute("Show Lyrics and Video finder Buttons", "1");
	
  tabs_main_attrib = custom_page_appearance.newAttribute("Show Tabs Icons only", "0");
  //tabs_hide_attrib = custom_page_appearance.newAttribute("Hide Tabs Completely", "0");
  tabs_show_attrib = custom_page_appearance.newAttribute("Enable Button to Show Hidden Tabs", "1");

	//tips_attrib = custom_page_appearance.newAttribute("Show Skin Tips", "1");
	//addMenuSeparator(custom_page_appearance);
	 


  if(wacup_attrib.getData() == "1") // v1.1..
  {
    waveseeker_attrib = custom_page_appearance.newAttribute("Use integrated Waveform Seeker", "1");
  }
  else
  {
    // Do nothing
  } // ..v1.1

}
