/*---------------------------------------------------
-----------------------------------------------------
Filename:	tabcontrol.m
Version:	1.0

Type:		maki
Date:		30. Okt. 2007 - 17:40  
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
		www.martin.deimos.de.vu
		
		
		
Tankevich Denis mods
-----------------------------------------------------
---------------------------------------------------*/

#include <lib/std.mi>
#include attribs/init_appearance.m

Function updateTabPos();
Function setAutoWidth(guiobject tab);

Class Text WatchText;

Global Boolean HAVE_ML, HAVE_VIDEO = TRUE;

Global GuiObject tabMl, GlassTab, tabVideo, tabVis, tabBrowser, tabPl;
Global WatchText txtMl, txtVideo, txtVis, txtBrowser, txtPL;
Global int startX, curX, Mw;
Global Button btnMl, btnPl;
Global Group RmGG,  MainG;

System.onScriptLoaded ()
{
	initAttribs_Appearance();
	HAVE_ML = stringToInteger(getParam());
	HAVE_VIDEO = System.hasVideoSupport();

	group sg = getScriptGroup();
    MainG = sg.findObject("grid.s2");
	tabML = sg.findObject("switch.ml");
	btnMl = sg.findObject("switch.ml");
	txtMl = tabMl.findObject("bento.tabbutton.normal.text");
	tabPL = sg.findObject("switch.pl");
	btnPl = sg.findObject("switch.pl");
	txtPl = tabPl.findObject("bento.tabbutton.normal.text");
	tabVis = sg.findObject("switch.vis");
	txtVis = tabMl.findObject("bento.tabbutton.normal.text");
	tabVideo = sg.findObject("switch.video");
	txtVideo = tabMl.findObject("bento.tabbutton.normal.text");
	tabBrowser = sg.findObject("switch.browser");
	txtBrowser = tabMl.findObject("bento.tabbutton.normal.text");
    RmGG = sg.findObject ("grid.s");
	GlassTab = sg.findObject ("Glass.Tab");
	
	startX = tabMl.getGuiX();

	updateTabPos();
	
	
}

updateTabPos ()
{	

	curX = startX;
	if (!HAVE_ML)
	{
		tabMl.hide();
	}
	else
	{
		curX += setAutoWidth(tabMl) + 1;
	}

	if (pl_tab_attrib.getData() == "1")
	{
		tabPL.setXmlParam("x", integerToString(curX));
		curX += setAutoWidth(tabPL) + 1;
		tabPL.show();
	}
	else
	{
		tabPL.hide();
	}

	if (HAVE_VIDEO)
	{
		tabVideo.setXmlParam("x", integerToString(curX));
		curX += setAutoWidth(tabVideo) + 1;
	}
	else
	{
		tabVideo.hide();
	}

	tabVis.setXmlParam("x", integerToString(curX));
	curX += setAutoWidth(tabVis) + 1;

	tabBrowser.setXmlParam("x", integerToString(curX));
	curX += setAutoWidth(tabBrowser);
	
	GlassTab.setXmlParam("w", integerToString(curX));
	
	curX = curX + 8;
	
	RmGG.setXmlParam("w", integerToString(curX));
	
	if (Right_tab_pos.getData() == "1")
	{
	    MainG.setXmlParam("relatx", "1");
		MainG.setXmlParam("x", integerToString(-Mw-62));
      
	}
   else if (Right_tab_pos.getData() == "0")
	{
	    MainG.setXmlParam("relatx", "0");
		MainG.setXmlParam("x", integerToString(0));
      
	}
	
    
}

int setAutoWidth (guiObject tab)
{
	text source = tab.findObject("bento.tabbutton.normal.text");
	int x = stringToInteger(source.getXmlparam("x"));
	int w = source.getAutoWidth();

	tab.setXmlParam("w", integerToString(2*x+w));
    Mw = 2*x + w + curX ;
	return 2*x + w;
}


pl_tab_attrib.onDataChanged ()
{
	if (pl_tab_attrib.getData() == "0")
	{
		setPrivateString(getSkinName(), "Pledit_pos", "top");
		if (btnPl.getActivated())
		{	
			btnMl.leftClick();
			btnMl.getParentLayout().sendAction("load_comp", "pledit", 0,0,0,0);	
		}
	}
	
	updateTabPos();
}

Right_tab_pos.onDataChanged ()
{

	updateTabPos();
}
